package bank;

/**
 * Class for representing bank cards. The class provides attributes for the PIN
 * of the card (abstracting from any kind of more advanced PIN storage concept)
 * and the account number. Cards can be invalidated by ATMs (used when cards are
 * confiscated), which is simulated using a boolean attribute.
 */
public class BankCard {

    public BankCard (final int accountNumber, final int correctPIN) {
    }

    /**
     * Determine whether a given PIN is correct for this card. If a wrong PIN
     * is entered three times in a row, the card is invalidated. For invalid
     * cards, this check always returns <code>false</code>.
     * 
     * @param pin
     *            the PIN that is supposed to be checked
     * @return <code>true</code> iff <code>pin</code> is correct and the
     *         card is valid
     */
    public boolean checkPin (int pin) {
    }

    /**
     * Validate or invalidate a card
     * 
     * @param valid if true, card is made valid, otherwise it is invalidated 
     */
    public void makeCardValid (boolean valid) {
    }

    /**
     * @return <code>true</code> iff <code>this</code> card is invalid
     */
    public boolean cardIsInvalid () {
    }

    /**
     * @return the account number of the account related to this card
     */
    public int getAccountNumber () {
    }


    public String toString() {
    }
}
