package bank;

/**
 * Class for representing the transaction kind deposit, i.e. the act of
 * paying in a certain amount of money to an account.
 * Objects of this class are immutable
 */
public class Deposit extends Transaction {

    public Deposit (final int date, final int amount) {
    }

    /**
     * The design pattern "Strategy" is used for implementing the
     * synchronisation of offline account proxies with the permanent accounts.
     * Invoking this method carries out <code>this</code> transaction on the
     * real account. Note that the deposit to the permanent account is
     * performed for the correct date
     * 
     * @param target
     *            the permanent account on which <code>this</code> transaction
     *            is supposed to be carried out
     */
    public void replay (PermanentAccount target) {
    }

    /**
     * @return the amount of money that is deposited
     */
    public int getAmount () {
    }

    public String toString () {
    }
}
